package net.jaekl.qd.util;

import java.io.ByteArrayInputStream;
import java.io.IOException;
import java.io.InputStream;
import java.nio.charset.Charset;
import java.util.ArrayList;

public class InputStreamMock extends InputStream {
	private ByteArrayInputStream m_bais;
	
	public InputStreamMock() { 
		m_bais = new ByteArrayInputStream(new byte[0]);
	}
	
	@Override
	public int read() throws IOException {
		return m_bais.read();
	}

	public void mock_append(byte[] addition) {
		byte[] old = readAll();
		byte[] combined = new byte[old.length + addition.length];
		for (int idx = 0; idx < old.length; ++idx) {
			combined[idx] = old[idx];
		}
		for (int idx = 0; idx < addition.length; ++idx) {
			combined[old.length + idx] = addition[idx];
		}
		
		mock_reset(combined);
	}
	
	public void mock_append(String addition, Charset charset) 
	{
		mock_append(addition.getBytes(charset));
	}
	
	public void mock_reset(byte[] newData) {
		m_bais = new ByteArrayInputStream(newData);
	}
	
	// Read all remaining bytes in the inputstream
	private byte[] readAll() {
		// This is horribly inefficient; don't use in production code
		ArrayList<Byte> data = new ArrayList<Byte>();
		int b = m_bais.read();
		while ((-1) != b) {
			data.add(Byte.valueOf((byte)b));
		}
		byte[] result = new byte[data.size()];
		for (int idx = 0; idx < result.length; ++idx) {
			result[idx] = data.get(idx).byteValue();
		}
		
		return result;
	}
}
